/* "eqcs_gate.cc"
 * Copyright (C) 1999 Peter Belkner <pbelkner@berlin.snafu.de>
 *
 * This file is part of the eqcs library. This library is free
 * software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; see the file COPYING.  If not, write to the
 * Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#ifdef __GNUG__
#pragma implementation
#endif

#include "eqcs_state.h"
#include "eqcs_gate_rep.h"
#include "eqcs_gate.h"

/*****************************************************************************\
*	gate																	  *
\*****************************************************************************/

EqcsGate::EqcsGate(rep_t *rep) : base_t(rep)
	{}

void EqcsGate::set(int i, int bit) const
	{ rep()->set(i, bit); }

EqcsState EqcsGate::operator()(const EqcsState &state) const
	{ return rep()->apply(state.rep()); }

ostream &operator<<(ostream &os, const EqcsGate &gate)
	{ return gate->put(os); }
