/* "eqcs_matrix.cc"
 * Copyright (C) 1999 Peter Belkner <pbelkner@berlin.snafu.de>
 *
 * This file is part of the eqcs library. This library is free
 * software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; see the file COPYING.  If not, write to the
 * Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#ifdef __GNUG__
#pragma implementation
#endif

#include <stdarg.h>
#include "eqcs_state.h"
#include "eqcs_matrix_rep.h"
#include "eqcs_matrix.h"

/*****************************************************************************\
*	matrix																	  *
\*****************************************************************************/

EqcsMatrix::EqcsMatrix(rep_t *rep) : base_t(rep)
	{}

EqcsMatrix::EqcsMatrix(int nqubits, ...)
{
	va_list ap;

	va_start(ap, nqubits);
	*this = new rep_t(nqubits, ap);
	va_end(ap);
}

EqcsMatrixRow EqcsMatrix::operator[](int row) const
	{ return rep()->get(row); }

/*****************************************************************************\
*	matrix row																  *
\*****************************************************************************/

EqcsMatrixRow::EqcsMatrixRow(rep_t *rep) : base_t(rep)
	{}

EqcsMatrixRow::complex_t &EqcsMatrixRow::operator[](int col) const
	{ return rep()->get(col); }

ostream &operator<<(ostream &os, const EqcsMatrixRow &row)
	{ return row->put(os); }
