/* "eqcs_qc.cc"
 * Copyright (C) 1999 Peter Belkner <pbelkner@berlin.snafu.de>
 *
 * This file is part of the eqcs library. This library is free
 * software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; see the file COPYING.  If not, write to the
 * Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#ifndef __GNUG__
#pragma implementation
#endif

#include "eqcs_qc_rep.h"
#include "eqcs_qc.h"

/*****************************************************************************\
*	quantum computer														  *
\*****************************************************************************/

EqcsQc::EqcsQc(rep_t *rep) : base_t(rep)
	{}

EqcsQc::EqcsQc(const EqcsState &state) : base_t(new rep_t(state))
	{}

void EqcsQc::prepare(const EqcsState &state) const
	{ rep()->prepare(state); }

EqcsState EqcsQc::observe(unsigned long bits) const
	{ return rep()->observe(bits); }

void EqcsQc::perform(const EqcsGate &gate) const
	{ rep()->perform(gate); }

void EqcsQc::perform(const EqcsGateArray &array) const
	{ rep()->perform(array); }

EqcsState EqcsQc::state() const
	{ return rep()->state(); }
